/*------------------------------------------------------------------------------
--  This file is a part of the libuc, microcontroler library
--  Copyright (C) 2013, Alexis Jeandet
--
--  This program is free software; you can redistribute it and/or modify
--  it under the terms of the GNU General Public License as published by
--  the Free Software Foundation; either version 3 of the License, or
--  (at your option) any later version.
--
--  This program is distributed in the hope that it will be useful,
--  but WITHOUT ANY WARRANTY; without even the implied warranty of
--  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--  GNU General Public License for more details.
--
--  You should have received a copy of the GNU General Public License
--  along with this program; if not, write to the Free Software
--  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
-------------------------------------------------------------------------------
--                 Author : Alexis Jeandet
--                   Mail : alexis.jeandet@gmail.com
-------------------------------------------------------------------------------*/
#ifndef THREAD_H
#define THREAD_H
#include <stdint.h>
#include <uhandle.h>
#include <streamdevices.h>

#ifdef __cplusplus
extern "C" {
#endif

typedef struct thread_t
{
    int (*func)(void*);
    void* __stack__;
    int __stackSize__;
    int __stackPointer__;
    int __programcounter__;
}thread_t;


int threadcreate(thread_t* thread,void* stack,int stackSize);
int threadstart(thread_t* thread);
int threadstop(thread_t* thread);


#ifdef __cplusplus
}
#endif
#endif //THREAD_H












